<template>
  <div class="pages-bos">
    <el-form class="pages-form" ref="queryFormRef" :model="queryParams" :inline="true" label-width="100px">
      <el-form-item>
        <el-button type="primary" plain @click="handleAdd" v-hasPermi="['parameter:device:add']">添加短信模板</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" border :data="templateSettingList" @selection-change="handleSelectionChange">
      <el-table-column label="ID" align="center" prop="id" v-if="true" />
      <el-table-column label="模板id" align="center" prop="templateId" />
      <el-table-column label="模板内容" align="center" prop="templateContent" />
      <el-table-column label="发送英文KEY" align="center" prop="sendKey" />
      <el-table-column label="作用" align="center" prop="effect" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:templateSetting:edit']">编辑</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:templateSetting:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <!-- 添加或修改短信模板配置对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="600px" append-to-body>
      <el-form ref="templateSettingFormRef" :model="form" :rules="rules" label-width="130px">
        <el-form-item label="模板id：" prop="templateId">
          <el-input v-model="form.templateId" placeholder="输入模板id" />
        </el-form-item>
        <el-form-item label="模板内容：" prop="templateContent">
          <el-input v-model="form.templateContent" type="textarea" placeholder="输入模板内容" />
        </el-form-item>
        <el-form-item label="发送英文KEY：" prop="sendKey">
          <el-input v-model="form.sendKey" placeholder="输入发送英文KEY" />
        </el-form-item>
        <el-form-item label="作用：" prop="effect">
          <el-input v-model="form.effect" placeholder="输入作用" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TemplateSetting" lang="ts">
import {
  listTemplateSetting,
  getTemplateSetting,
  delTemplateSetting,
  addTemplateSetting,
  updateTemplateSetting
} from '@/api/setting/templateSetting/index';
import { TemplateSettingVO, TemplateSettingQuery, TemplateSettingForm } from '@/api/setting/templateSetting/types';
const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const templateSettingList = ref<TemplateSettingVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const setType = ref('0');

const queryFormRef = ref<ElFormInstance>();
const templateSettingFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: TemplateSettingForm = {
  id: undefined,
  templateId: undefined,
  templateContent: undefined,
  sendKey: undefined,
  effect: undefined,
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<TemplateSettingForm, TemplateSettingQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    templateId: undefined,
    templateContent: undefined,
    sendKey: undefined,
    effect: undefined,
    status: undefined,
    params: {}
  },
  rules: {
    templateId: [{ required: true, message: '模板id不能为空', trigger: 'blur' }],
    templateContent: [{ required: true, message: '模板内容不能为空', trigger: 'blur' }],
    sendKey: [{ required: true, message: '发送英文KEY不能为空', trigger: 'blur' }],
    effect: [{ required: true, message: '作用不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询短信模板配置列表 */
const getList = async () => {
  loading.value = true;
  const res = await listTemplateSetting(queryParams.value);
  templateSettingList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

const handleClick = (tab: TabsPaneContext) => {
  setType.value = tab.paneName as string;
  // queryParams.value.setType = tab.paneName as string;
  getList();
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  templateSettingFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: TemplateSettingVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加短信模板配置';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: TemplateSettingVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getTemplateSetting(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改短信模板配置';
};

/** 提交按钮 */
const submitForm = () => {
  templateSettingFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateTemplateSetting(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addTemplateSetting(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: TemplateSettingVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除短信模板配置编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delTemplateSetting(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/templateSetting/export',
    {
      ...queryParams.value
    },
    `templateSetting_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
